<% Option Explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/FileUploader.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/Image.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/sessionValidator.vbs"></script><%
CheckHeader "UploadNew.aspx"

Dim Title
If (Request.ServerVariables("REQUEST_METHOD") = "POST") Then
    DoUpload
Else
    If Request.QueryString("err") = "tooLarge" Then Alert "The file you submitted was too large. The limit is 100,000 bytes."
End If

Sub DoUpload

	Call ValidateSession
	Dim uploader : Set uploader = New FileUploader
	Dim img : Set img = New Image
    
    Dim error : error = false
	On Error Resume Next
	uploader.Upload
    If Err.Number Then error = true
	On Error Goto 0

    Title = uploader.Form("Title")

    IF error Then
        Alert "There was error while processing your upload. The file may have been too big; the maximum size is 100,000 bytes."
        Exit Sub
    End If
	
	If Not IsObject(uploader.Files("Image")) Then
		Alert "It doesn't look like a file was uploaded. Whoops."
		Exit Sub
	End If
	
	If Not img.LoadFromBytes(uploader.Files("Image").FileData) Then
		Alert "There was an error loading the uploaded file. Perhaps it's not a picture? Only JPG, GIF, and PNG are allowed."
		Exit Sub
	End If	
	
	If img.Type = "BMP" Then
		Alert "BMP pictures are not allowed at this time. They take up too much space. Save as a GIF instead."
		Exit Sub
	End If
	
	If img.Width > 550 Or img.Height > 600 Then
		Alert _
			"The picture you uploaded is too wide or too high." & vbCrLf & _ 
			vbCrLf & _
			"Pictures cannot be any wider than 550 pixels or higher than 600 pixels. " & vbCrLf & _
			vbCrLf & _			
			"The picture you uploaded is " & img.Width & " pixels wide and " & img.Height & " pixels high."
		Exit Sub
	End If

	If img.FileSize > 100000 Then
		Alert "The file you uploaded is too large. There is a limit of 100,000 bytes."
		Exit Sub
	End If

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = "[Create Or Replace Image]"
		.CommandType = adCmdStoredProc
		.Parameters.Append .CreateParameter("@ImageId", adInteger, adParamOutput, 8, Null)
		.Parameters.Append .CreateParameter("@Username", adVarChar, adParamInput, 20, Session("Username"))			
		.Parameters.Append .CreateParameter("@Title", adVarChar, adParamInput, 50, Title)
		.Parameters.Append .CreateParameter("@Tags", adVarChar, adParamInput, 6000, Replace(uploader.Form("Tags"), vbCrLf, " "))
		.Parameters.Append .CreateParameter("@Content", adLongVarBinary, adParamInput, 2147483647)
        
		uploader.Files("Image").SaveToDataBase(.Parameters("@Content"))
		.Execute
	End With

	Response.Redirect "./"

End Sub
%>


	  <form enctype="multipart/form-data" method="post" id="mainContent">
	  <h1><a href="../">My Stuff</a> &raquo; <a href="./">Pictures</a> &raquo; Add Picture</h1>
	  <h2>Picture Title</h2>
	  <p style="margin-bottom: 1rem;">In storygames, this title will show up when hovering the mouse over the image.
        <br/>
	    <input type="text" name="Title" value="<%=server.HTMLEncode(Title)%>" autofocus />
	  </p>
      <h2>Picture Tags</h2>
      <p>
      <span>Use tags to organize images, e.g. to identify all images used in a storygame. Separate them with commas.</span><br />
	  <textarea rows="4" cols="52" name="Tags"></textarea>
      </p>
	  <h2>File</h2>
	  <p>
	  <input type="file" name="Image" onchange="if (this.form.Title.value=='') this.form.Title.value=this.value.substring(this.value.lastIndexOf('\\')+1);"/>
	  </p>
	  <p>
	  <input type="submit" value="Upload New Picture" onclick="if (this.form.Title.value=='') {alert('You forgot the Title.'); return false;}" />
	  &nbsp;
	  <input type="button" value="Cancel" onclick="location='./';">
	  </p>
	  </form>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
