
Class DifficultyLevel
	Public ID
	Public ImageUrl
	Public Description

	Private Sub Class_Initialize() : Clear : End Sub
	
	Private Sub Clear()
		ID = 0
		ImageUrl = "/i/spacer.gif"
		Description = "Not Set / Unknown"
	End Sub
	
	Private Sub SetProperties(a,b)
		ID = a : ImageUrl = "/i/difficulty/" & a & ".gif" : Description = b
	End Sub
	Public Function ToString() : ToString = ID & " - " & Description : End Function	
	Public Sub Load(DifficultyID)
		Clear
		Select Case DifficultyID
			Case 1 : SetProperties 1,"no possible way to lose"
			Case 2 : SetProperties 2,"walk in the park"
			Case 3 : SetProperties 3,"trek through the forest"
			Case 4 : SetProperties 4,"march in the swamp"
			Case 5 : SetProperties 5,"run through the jungle"
			Case 6 : SetProperties 6,"wandering through the desert"
			Case 7 : SetProperties 7,"wade in shark infested water"
			Case 8 : SetProperties 8,"mosie through a minefield"
		End Select
	End Sub
End Class

Function LoadAllDifficultyLevels
	Dim i,Difficulties(7)
	For i = 0 To UBound(Difficulties)
		Set Difficulties(i) = New DifficultyLevel
		Difficulties(i).Load(i+1)
	Next
	LoadAllDifficultyLevels = Difficulties
End Function

Function WriteDifficultiesOptions(selected)
	Dim Difficulties : Difficulties = LoadAllDifficultyLevels
	Dim i : For i = 0 To UBound(Difficulties)
		Response.Write "<option value=""" & Difficulties(i).ID & """"
		If Difficulties(i).ID = selected Then Response.Write " selected=""true"""
		Response.Write ">" & Difficulties(i).ToString & "</option>"
	Next
End Function