<%Option Explicit%>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/fckeditor.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/UserRoles.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/Components/Article.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%
CheckHeader "editArticle.aspx"

	Dim myArticle : Set myArticle = New Article
	Dim target : target = "../"
	
	If Request.ServerVariables("REQUEST_METHOD")="POST" Then 
		myArticle.LoadFromForm(Request.Form)
	ElseIf IsNumeric(Request.QueryString("ArticleId")) And Request.QueryString("ArticleId")<>"" Then
		myArticle.Load Request.QueryString("ArticleId")
	End If
	
    If Not IsEmpty(myArticle.ArticleId) And _
       myArticle.UserName <> Session("Username") And _
       Not IsInRole("Articles Administrator") Then
			Response.Redirect "/help/articles/article.aspx?articleId=" & myArticle.ArticleId
    End If

	If Not IsEmpty(Request.Form("save")) Then : myArticle.Save : Response.Redirect target
	If Not IsEmpty(Request.Form("accept")) Then
		If myArticle.UserName = Session("Username") And Not IsInRole("Site Administrator") Then
			Response.Write "<script defer>alert('You can\'t Accept your own articles. Remember, never be your own editor.');</script>"
			myArticle.Save
			myArticle.Load myArticle.ArticleId
		Else
			myArticle.Accept
			myArticle.Save
			Response.Redirect target
		End If
	End If
	If Not IsEmpty(Request.Form("submit")) Then : myArticle.Save : myArticle.Submit : Response.Redirect target : End If
	If Not IsEmpty(Request.Querystring("action")) Then : myArticle.Delete : Response.Redirect target : End If
%>


<form method="post"><div id="maincontent">

<h1>Write An Article</h1>
Articles are an excellent way to share your knowledge of the site with other members. You can also score some big EXP Points by doing so.
You can use this form to edit and submit articles.

<h2>Author</h2>
<% If IsInRole("Articles Administrator") Then %>
	<% If myArticle.Username = null or myArticle.Username = "" Then %>
        <input type="text" size="25" maxlength="20" name="Username" value="<%=Server.HTMLEncode(Session("Username"))%>">
    <% Else %>
        <input type="text" size="25" maxlength="20" name="Username" value="<%=Server.HTMLEncode(myArticle.Username)%>">
	<% End If %>
<% Else %>
<%=Session("Username")%>
<% End If %>

<h2 style="margin-top:8px;">Title</h2>
<input type="text" size="75" maxlength="100" name="Title" value="<%=Server.HTMLEncode(myArticle.Title)%>"
	<% If IsEmpty(myArticle.ArticleId) Then Response.Write(" autofocus") End If %>>

<h2 style="margin-top:8px;">Category</h2>
<select name="Category" id="Category">
	<option value=""></option>
	<option value="The Website"<% If ("The Website" = myArticle.Category) Then Response.Write(" selected") End If %>>The Website</option>
	<option value="Storywriting"<% If ("Storywriting" = myArticle.Category) Then Response.Write(" selected") End If %>>Storywriting</option>
	<option value="Advanced Editor"<% If ("Advanced Editor" = myArticle.Category) Then Response.Write(" selected") End If %>>Advanced Editor</option>
	<option value="Scripting"<% If ("Scripting" = myArticle.Category) Then Response.Write(" selected") End If %>>Scripting</option>
	<option value="Interviews"<% If ("Interviews" = myArticle.Category) Then Response.Write(" selected") End If %>>Interviews</option>
</select>

<h2 style="margin-top:8px;">Difficulty</h2>
<select name="Difficulty" id="Difficulty">
	<option value="Beginner"<% If ("Beginner" = myArticle.Difficulty) Then Response.Write(" selected") End If %>>Beginner</option>
	<option value="Intermediate"<% If ("Intermediate" = myArticle.Difficulty) Then Response.Write(" selected") End If %>>Intermediate</option>
	<option value="Expert"<% If ("Expert" = myArticle.Difficulty) Then Response.Write(" selected") End If %>>Advanced</option>
</select>

<h2 style="margin-top:8px;">Abstract (two or three sentences)</h2>
<textarea rows="3" cols="55" name="Abstract"><%=Server.HTMLEncode(myArticle.Abstract)%></textarea>

<h2 style="margin-top:8px;">Body</h2>
<%  
	With (New FCKeditor)
	    .Autofocus = Not IsEmpty(myArticle.ArticleId)
		.Width = "100%"
		.Value = myArticle.Body
		.Height = "600px"
		.Create "Body"
	End With
%>

<br/><br/>

<% If myArticle.Status = "Incomplete" Then %>
  <input type="submit" name="save" value="Save Incomplete">
  &nbsp;
  <input type="submit" name="submit" value="Save &amp; Submit" onClick="return (confirm('Are you sure you want to submit now? \n\nOnce submitted, you will need to unsubmit to make further changes.'));">
  &nbsp;
  <input type="button" value="Cancel" onClick="location='.'">
  <% If Not IsEmpty(myArticle.ArticleId) Then %>
    <p>If you have changed your mind, and decided not to write this article afterall, you may <a href="?action=delete&ArticleId=<%=myArticle.ArticleId%>" onClick="return (confirm('Are you sure? This cannot be undone'));">delete it</a>.</p>
  <% End  If %>

<% ElseIf myArticle.Status = "Submitted" Then %>
  <input type="submit" name="save" value="Save">
  &nbsp;
  <input type="submit" name="accept" value="Accept Article">
  &nbsp;
  <input type="button" value="Cancel" onClick="location='.'">
<% Else %>  
  <input type="submit" name="save" value="Save">
  &nbsp;
  <input type="button" value="Cancel" onClick="location='.'">
<% End If %>



<input type="hidden" name="ArticleId" value="<%=myArticle.ArticleId%>">
	  
	  </div></form>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
