<% Option Explicit %>
<!-- #include file="../../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../../Includes/sessionValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="../duel.vbs"></script>
<%
CheckHeader "newDuel.aspx"

ValidateSession

Dim target
If Request("target") = "" Then target = "../" Else target = Request("target")
	
Dim ChallengeeUsername
If Not IsEmpty(Request.Form("ChallengeeUsername")) _
	Then ChallengeeUsername = Request.Form("ChallengeeUsername") _
	Else ChallengeeUsername = Request.QueryString("Username")

If Not IsEmpty(Request.Form("duel")) Then IssueDuel
Sub IssueDuel
	With New Duel
		.DuelType = "Rock Paper Scissors"
		.LoadFromForm Request.Form
		If .ChallengerChoice<>"Rock" And _
		   .ChallengerChoice<>"Paper" And _
		   .ChallengerChoice<>"Scissors" Then Response.Redirect Target
		If .IssueChallenge Then
			If LCase(.ChallengeeUsername)="cysid" Then
				Randomize Timer
				Select Case Int(Rnd * 3)
					Case 0 : .ChallengeeChoice = "Rock"
					Case 1 : .ChallengeeChoice = "Paper"
					Case Else : .ChallengeeChoice = "Scissors"
				End Select
				.Winner = CalculateWinner(.ChallengeeChoice, .ChallengerChoice)
				.Accept
				'target = "../duel.asp?DuelId=" & .DuelId
			End If				
			AlertWithRedirect "Your challenge was issued!", target
		Else
			Alert "There was an error with your wager:" & vbCrLf & .ErrorMessage
		End If
	End With

End Sub

Function CalculateWinner(ChallengeeChoice, ChallengerChoice)
	'Draw Conditions
	If ChallengeeChoice = ChallengerChoice Then
		CalculateWinner = "Draw"
	'Challengee Winning Conditions
	ElseIf ChallengeeChoice="Rock" And ChallengerChoice="Scissors" Then
		CalculateWinner = "Challengee"
	ElseIf ChallengeeChoice="Scissors" And ChallengerChoice="Paper" Then
		CalculateWinner = "Challengee"
	ElseIf ChallengeeChoice="Paper" And ChallengerChoice="Rock" Then
		CalculateWinner = "Challengee"
	'Challenger Winning Combinations
	ElseIf ChallengerChoice="Rock" And ChallengeeChoice="Scissors" Then
		CalculateWinner = "Challenger"
	ElseIf ChallengerChoice="Scissors" And ChallengeeChoice="Paper" Then
		CalculateWinner = "Challenger"
	ElseIf ChallengerChoice="Paper" And ChallengeeChoice="Rock" Then
		CalculateWinner = "Challenger"
	End If
End Function

%>

<html><!-- InstanceBegin template="/Templates/SecondaryPage.dwt.asp" codeOutsideHTMLIsLocked="false" -->
<!-- InstanceBeginEditable name="head" -->
<script language="javascript">
function validate(frm)
{
	if (frm.Wager.selectedIndex==0)
	{
		alert("Whoops! You need to select a wager ...");
		return false;
	}
	
	if (!frm.ChallengerChoice[0].checked && !frm.ChallengerChoice[1].checked && !frm.ChallengerChoice[2].checked)
	{
		alert("You didn't select a throw ...");
		return false;
	}
	
	if (confirm("Are you sure you'd like to issue this challenge?")) frm.submit();
}
</script>

<form method="post">
<div id="maincontent">
 <h1>Rock Paper Scissors Duel</h1>
 <p>The rules are simple. When you hit the DUEL button, the points you wagered will deducted from your account and placed in escrow. If your oponent declines the duel (or does not accept in suitable time), your points will be returned. If you win the duel, your points will be returned in double. You can probably guess what happens if you don't win the duel ... </p>
 <table border="0" cellspacing="5" cellpadding="0">
   <tr>
     <td><table border="0" cellspacing="0" cellpadding="3">
       <tr>
         <td valign="top"><label>Member To Challenge</label>
         </td>
         <td><%=ChallengeeUsername%></td>
       </tr>
       <tr>
         <td valign="top"><label>Points To Wager</label></td>
         <td><select name="Wager">
             <option value="">Select Wager</option>
<% Dim i : For i = 1 to 5 %><option value="<%=i%>" <%If CStr(i) = Request.Form("Wager") Then Response.Write " selected"%>><%=i%></option><% Next%>
         </select></td>
       </tr>
       <tr>
         <td valign="top"><label>Hand To Throw </label></td>
         <td><table border="0" cellspacing="3" cellpadding="0">
             <tr>
               <td style="background-color:#FFFFFF; border:1px solid #000033 "><label for="radRock"><img src="rock.gif" width="50" height="50" /></label></td>
               <td style="background-color:#FFFFFF; border:1px solid #000033 "><label for="radPaper"><img src="paper.gif" width="50" height="50" /></label></td>
               <td style="background-color:#FFFFFF; border:1px solid #000033 "><label for="radScissors"><img src="scissors.gif" width="50" height="50" /></label></td>
             </tr>
             <tr>
               <td align="center"><input type="radio" name="ChallengerChoice" value="Rock" id="radRock" <%If Request.Form("ChallengerChoice")="rock" Then Response.Write "checked"%>/></td>
               <td align="center"><input type="radio" name="ChallengerChoice" value="Paper" id="radPaper" <%If Request.Form("ChallengerChoice")="paper" Then Response.Write "checked"%>/></td>
               <td align="center"><input type="radio" name="ChallengerChoice" value="Scissors" id="radScissors" <%If Request.Form("ChallengerChoice")="scissors" Then Response.Write "checked"%>/></td>
             </tr>
         </table></td>
       </tr>
       <tr>
         <td valign="top"><div align="center"> </div></td>
         <td valign="top">
<input type="button" value="Duel" onClick="validate(this.form)" />
&nbsp;

<!--<input name="cancel" type="button" value="Cancel" />-->
<input type="button" value="Cancel" onclick="location=this.form.target.value" />

<input type="hidden" name="ChallengeeUsername" value="<%=Server.HTMLEncode(ChallengeeUsername)%>">
<input type="hidden" name="duel" value="duel">
<input type="hidden" name="target" value="<%=Server.HTMLEncode(target)%>">
</td>
       </tr>
     </table></td>
     <td valign="top" width="25">&nbsp;</td>
     <td valign="top">
	  <h2 style="margin-top: 8px; ">Rock breaks Scissors</h2>
      <h2 style="margin-top: 8px; ">&nbsp;&nbsp;Scissors cut Paper</h2>
  	  <h2 style="margin-top: 8px; ">&nbsp;&nbsp;&nbsp;&nbsp;Paper covers Rock</h2></td>
   </tr>
 </table>
</div></form>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>