<% Option Explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="../../includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../../includes/sessionValidator.vbs"></script><%
CheckHeader "SelectDuel.aspx"

ValidateSession

Dim Username
Username = Request("Username")
'If Request("Username")="" Then Response.Redirect(".")

If Not IsEmpty(Request.Form("continue")) Then Continue

Sub Continue

	If Request.Form("Username")="" Then 
		Alert "Whoops! Username is a required field"
		Exit Sub
	End If

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = _
			"SELECT 'Y' AS [Duel Indicator] " & _
			"  FROM [Users] " & _
			" WHERE [Username] = ? "
		.Parameters.Append .CreateParameter("Username", adVarChar, adParamInput, 20, Request.Form("Username") )
		With .Execute
			If .EOF Then
				Alert "It looks like """ &  Request.Form("Username") & """ is not a member of the site ... "
			ElseIf .Fields("Duel Indicator") = "N" Then
				Alert Request.Form("Username") & " is not accepting duels at this time."
			Else
				redir = True
			End If
		End With
	End With
	
	If redir Then Response.Redirect "selectDuel.asp?username=" & Server.URLEncode(Request.Form("Username"))

End Sub

%>

<div id="maincontent">

<h1><a href="../">My Stuff</a><span> &raquo; Duels</span></h1>
<h2>Challenge <%=Username%> to a Duel</h2>
<p>Select the type of challenge you would like to issue your opponent. As you earn more points and participate in more duels, more dueling options will become available to you. At this time you have all available duels. </p>
<div style="padding:15px;">

	<table border="0" cellspacing="0" cellpadding="3">
		<tr><td colspan="2"><hr noshade="noshade" color="#000033" size="1px"/></td></tr>
		<tr>
			<td><img style="float:left; margin-right:10px; margin-bottom:10px; " src="toggle/image.gif" width="175" height="175" /></td>
			<td valign="top" style="text-align:justify "><p><span class="secNavBarSelectedLink">Toggle</span> is a modern version of the traditional leadership challenge of the Inupiaq Alaskan-native people. A disgruntled tribesman would carve two cubes from whale blubber and present one of them, the Ayaufaruq Kigunniq (&quot;blind box&quot;), to the chieftain who was to mark the cube with an X, but only if his opponent did the same. The loser of the challenge was banished from his people. </p>
				<p>You may wager from 1 to 5 points.</p>
				<p align="center">
					<input type="button" name="Button" value="I Choose Toggle" onClick="location='toggle/newduel.asp?<%=Request.QueryString()%>'" />
				</p></td>
		</tr>
		<tr><td colspan="2"><hr noshade="noshade" color="#000033" size="1px"/></td></tr>		  
	</table>	
	
	<table border="0" cellspacing="0" cellpadding="3">
		<tr>
			<td><img style="float:left; margin-right:10px; margin-bottom:10px; " src="rockpaperscissors/image.gif" width="175" height="175" /></td>
			<td valign="top" style="text-align:justify "><p><span class="secNavBarSelectedLink">Rock Paper Scissors</span> is the most widely played game in the world today. It is known to everyone young and old, usually by a different name: <em>Ching-Chong-Cha</em> in Africa, <em>Janken</em> in Japan, <em>Even Neyar uMisparayim</em> in Israel, and <em>sten, sax, p&aring;se</em> in Sweden. Primate biologists have even observed some orangutan cultures playing a similar variation.</p>
				<p>You may wager from 1 to 5 points.</p>
				<p align="center">
					<input type="button" name="Button" value="I Choose Rock Paper Scissors" onClick="location='rockpaperscissors/newduel.asp?<%=Request.QueryString()%>'" />
				</p></td>
		</tr>
	</table>

	<table border="0" cellspacing="0" cellpadding="3">
		<tr><td colspan="2"><hr noshade="noshade" color="#000033" size="1px"/></td></tr>
		<tr>
			<td><img style="float:left; margin-right:10px; margin-bottom:10px; " src="rps/images/rpslogo.gif" /></td>
			<td valign="top" style="text-align:justify ">
				<p><span class="secNavBarSelectedLink">RPS</span> is based on the ever-popular game Rock Paper Scissors. As you gain
				more experience points on the site, you'll gain access to more gestures to use against your 
				opponents. There are 
				<em>twenty-five different gestures</em>, providing over 300 different 
				combinations.
				The concept of RPS was pioneered by <a href="http://www.umop.com/rps25.htm">David C. Lovelace</a>, so make sure to check out all of his cool 
				<a href="http://www.cafepress.com/animalbabies/862340">RPS-25 Stuff</a>.
				</p>
				<p>You may wager from 1 to 5 points.</p>
				<p align="center">
					<input type="button" name="Button" value="I Choose R.P.S." onClick="location='rps/default.aspx?<%=Request.QueryString()%>&mode=newduel'" />
				</p></td>
		</tr>
		<tr><td colspan="2"><hr noshade="noshade" color="#000033" size="1px"/></td></tr>
		
	</table>
	

	
</div>
</div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>