<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%CheckHeader "default.aspx" %>

<Script>
function deleteImage( imageId )
{
	var msg = 
		'Are you sure you want to permanently delete this picture from your game?\n' +
		'This will leave blank spots on pages where you have used this picture.\n\n' +
		'This cannot be undone.';
	if (confirm(msg))
	{
		location = 'deleteImage.asp?target=' + escape(location) + '&ImageId=' + imageId;
	}
}

</Script>
<h1><a href="../">My Stuff</a> &raquo; Pictures</h1>
<input style="display: block; margin-bottom: 0.5rem; margin-top: 0.5rem;" type="button" value="Upload New Picture" onclick="location='uploadNew.aspx'"/>
<%
Dim Conn : Set Conn = Server.CreateObject("ADODB.Connection")
Dim Tag
With Conn
  .Open Application("ConnectionString")
  .CursorLocation = adUseClient
End With

Dim Rst

With Server.CreateObject("ADODB.Command")
    .ActiveConnection = Conn
    .CommandText = _
        "SELECT DISTINCT IT.[Tag] " & _
        "  FROM [Image Tags] IT (NOLOCK) " & _
        "       INNER JOIN [User Images] UI (NOLOCK) " & _
        "               ON UI.[Image ID] = IT.[Image ID] " & _
        "              AND UI.[Username] = ? " & _
        " ORDER BY IT.[Tag]"
    .Parameters.Append .CreateParameter("@Username", adVarChar, adParamInput, 20, Session("Username"))
    Set Rst = .Execute
End With

' Write out tag selector
Set Tag = Request.QueryString("Tag")
If Not IsNull(Tag) Then
    If Trim(Tag) = "" Then Tag = null
End If
Response.Write "Display by tag: "
If IsNull(Tag) Then Response.Write "[all]" Else Response.Write "[<a href=""default.aspx"">all</a>]"
With Rst
    Do While Not .EOF
        If .Fields("Tag") = Tag Then
            Response.Write " [" & Server.HTMLEncode(.Fields("Tag")) & "]"
        Else
            Response.Write " [<a href=""default.aspx?tag=" & Server.URLEncode(.Fields("Tag")) & """>" & Server.HTMLEncode(.Fields("Tag")) & "</a>]"
        End If

        .MoveNext
    Loop
End With
Rst.Close
Response.Write "<br />"

' Load images
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = _
		"SELECT I.[Image Id], I.[Title], IT.[Tag] " & _
		"  FROM [Images] I (NOLOCK) " & _
		"       INNER JOIN [User Images] UI (NOLOCK) " & _
		"               ON UI.[Image Id] = I.[Image Id] " & _
		"              AND UI.[Username] = ? " & _
        "       LEFT JOIN [Image Tags] IT (NOLOCK) " & _
        "              ON IT.[Image ID] = I.[Image ID] " & _
        " WHERE ( " & _
        "           (   ? IS NULL ) " & _
        "        OR EXISTS ( SELECT * " & _
        "                      FROM [Image Tags] _IT " & _
        "                     WHERE IT.[Image ID] = _IT.[Image ID] " & _
        "                       AND _IT.[Tag] = ? ) " & _
        "       ) " & _
		" ORDER BY I.[Image Id], IT.[Tag]"
	.Parameters.Append .CreateParameter("@Username", adVarChar, adParamInput, 20, Session("Username"))
	.Parameters.Append .CreateParameter("@Tag1", adVarChar, adParamInput, 50, Tag)
	.Parameters.Append .CreateParameter("@Tag2", adVarChar, adParamInput, 50, Tag)

	Set Rst = .Execute
End With

If Rst.EOF Then
	Response.Write "You have no pictures in your file."
Else
	Dim Index : Index = 0
    Dim LastId : LastId = -1
	Dim PageNumber
		If IsNumeric(Request.QueryString()) And Request.QueryString()<>"" Then
			PageNumber  = Clng(Request.QueryString())
		Else
			PageNumber = 1
		End If
	With Rst
		.PageSize = 30
		'.CacheSize = 30
		.AbsolutePage = PageNumber
		
		PageSelector .PageCount, PageNumber
		Response.Write "<table cellpadding=""0"" cellspacing=""20"" border=""0"">"
		Do While Not .EOF And Index < .PageSize
            LastId = .Fields("Image Id")

			If (Index Mod 6) = 0 Then
				If Index > 0 Then Response.Write "</tr>"
				Response.Write "<tr valign=""top"">"
			End If
			Response.Write "<td align=""center"" style=""width: 80px;"">"
			Response.Write "<a href=""../../i/?" & .Fields("Image Id").Value & """ target=""_blank"">"
			Response.Write _
				"<img src=""../../i/?" & .Fields("Image Id").Value & """" & _
				" alt=""" & Server.HTMLEncode(.Fields("Title").Value) & """" & _
				" width=""75"" height=""75"" vspace=""5"" border=""0"">"
			Response.Write "</a><br/>"
			Response.Write  _
				"<img src=""images/edit.gif"" alt=""Edit Picture""" & _
				" style=""cursor:hand; cursor:pointer""" & _
				" onclick=""location='edit.aspx?" & .Fields("Image Id").Value & "';""/>"			
			Response.Write "&nbsp;&nbsp;"
			Response.Write  _
				"<img src=""images/delete.gif"" alt=""Delete Picture""" & _
				" style=""cursor:hand; cursor:pointer""" & _
				" onclick=""deleteImage(" & .Fields("Image Id").Value & ")""/><div style=""font-size: 7pt; width: 75px; overflow: hidden;"">Tags: "

            ' Loop through/write out tags
            If Not IsNull(.Fields("Tag")) Then
                Do While LastId = .Fields("Image Id")
                    Response.Write Server.HTMLEncode(.Fields("Tag"))
                    .MoveNext
                    If .EOF Then Exit Do
                    If LastId = .Fields("Image Id") Then Response.Write ", "
                Loop
            Else
                .MoveNext
            End If

			Response.Write "</div></td>"				
			Index = Index + 1
		Loop
		Response.Write "</table>"
		PageSelector .PageCount, PageNumber
		.Close
	End With
	
End If

Conn.Close

Sub PageSelector(PageCount, CurrentPage)
	If PageCount <= 1 Then Exit Sub
	Response.Write "<p align=""right"" style=""padding-right:20px"">"
	Dim i : For i = 1 To PageCount
		If i > 1 Then Response.Write "&nbsp;|&nbsp;"
		If i = CurrentPage Then
			Response.Write "<strong>" & i & "</strong>"
		Else
			Response.Write "<a href=""?" & i & """>" & i & "</a>"
		End If
	Next
	Response.Write "</p>"
End Sub

%>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>